<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Controller\Admin;

use Eccube\Controller\AbstractController;
use Plugin\Proteger\Entity\Proteger;
use Plugin\Proteger\Form\Type\Admin\ProtegerType;
use Plugin\Proteger\Repository\ProtegerRepository;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;

class ProtegerController extends AbstractController
{

    /**
     * @var ProtegerRepository
     */
    private $protegerRepository;

    /**
     * ProtegerController constructor.
     * @param ProtegerRepository $protegerRepository
     */
    public function __construct(ProtegerRepository $protegerRepository)
    {
        $this->protegerRepository = $protegerRepository;
    }

    /**
     * @Route("/%eccube_admin_route%/proteger", name="admin_proteger", methods={"GET"})
     * @Template("@Proteger/admin/Proteger/index.twig")
     */
    public function index()
    {
        $Protegers = $this->protegerRepository->findAll();

        return [
            'protegers' => $Protegers,
        ];
    }

    /**
     * @Route("/%eccube_admin_route%/proteger/new", name="admin_proteger_new", methods={"GET", "POST"})
     * @Route("/%eccube_admin_route%/proteger/edit/{id}", requirements={"id" = "\d+"}, name="admin_proteger_edit", methods={"GET", "POST"})
     * @Template("@Proteger/admin/Proteger/edit.twig")
     *
     * @param Request $request
     * @param Proteger|null $Proteger
     * @return array
     */
    public function edit(Request $request, Proteger $Proteger = null)
    {
        $Proteger = $Proteger ?: new Proteger();
        $builder = $this->formFactory->createBuilder(ProtegerType::class, $Proteger);

        $form = $builder->getForm();
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->protegerRepository->save($Proteger);
            $this->entityManager->flush();

            $this->addSuccess('admin.common.save_complete', 'admin');

            return $this->redirectToRoute('admin_proteger');
        }

        return [
            'form' => $form->createView(),
        ];
    }
}
