<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Controller;

use Eccube\Repository\ProductRepository;
use Eccube\Common\EccubeConfig;
use Plugin\Proteger\Dao\ProductDao;
use Plugin\Proteger\E2V\ProductE2V;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;
use Symfony\Component\Routing\Annotation\Route;

/**
 * Class ProductsController
 * @package Plugin\Proteger\Controller
 */
class ProductsController extends AbstractController
{
    /**
     * @var ProductDao
     */
    protected $productDao;

    /**
     * @var ProductRepository
     */
    protected $productRepository;

    /**
     * ProductsController constructor.
     *
     * @param ProductDao $productDao
     * @param ProductRepository $productRepository
     */
    public function __construct(
        ProductDao $productDao,
        ProductRepository $productRepository
    ) {
        $this->productDao = $productDao;
        $this->productRepository = $productRepository;
    }

    /**
     * @Route("/proteger/products", name="proteger-products")
     * @param Request $request
     *
     * @return Response
     */
    public function index(Request $request)
    {
        return parent::index($request);
    }

    /**
     * @param Request $request
     *
     * @return JsonResponse
     * @throws NotFoundHttpException
     */
    protected function process(Request $request)
    {
        switch ($request->getMethod()) {
	    case Request::METHOD_GET:
                return $this->onGet($request);

            default:
        }
        throw new BadRequestHttpException();
    }

    /**
     * @param Request $request
     *
     * @return JsonResponse
     */
    protected function onGet(Request $request)
    {
        return $this->createResponse(ProductE2V::convert($this->productDao->getProducts($request)));
    }
}
