<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Dao;

use Eccube\Entity\Product;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class ProductDao
 * @package Plugin\Proteger\Dao
 */
class ProductDao extends AbstractDao
{
    /**
     * 商品情報を取得
     *
     * @param Request $request
     *
     * @return Product[]
     */
    public function getProducts(Request $request)
    {
        $qb = $this->createQueryBuilder()
            ->select('p')
            ->from('Eccube\Entity\Product', 'p')
            ->orderBy('p.id', 'DESC');

        $criteria = static::buildCriteria($request, array(
	    'id' => null,
        ));

        if (!is_null($criteria['id'])) {
            $idList = is_array($criteria['id']) ? $criteria['id'] : array($criteria['id']);

            $qb
                ->andWhere('p.id IN (:id_list)')
                ->setParameter('id_list', $idList);
        }

        $this->paging($qb, $request);

        return $qb->getQuery()->execute();
    }
}
