<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\E2V;

use Eccube\Entity\ProductClass;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;

/**
 * Class ProductClassE2V
 * @package Plugin\Proteger\E2V
 */
class ProductClassE2V
{
    public static function converts($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $productClass) {
            if (!$productClass instanceof ProductClass) {
                throw new BadRequestHttpException();
            }

            $view[] = array(
                'id' => $productClass->getId(),
                'code' => $productClass->getCode(),
		'price01' => $productClass->getPrice01(),
		'price02' => $productClass->getPrice02(),
		'create_date' => $productClass->getCreateDate() ?
		    $productClass->getCreateDate()->format('Y-m-d H:i:s') : null,
		'update_date' => $productClass->getUpdateDate() ?
		    $productClass->getUpdateDate()->format('Y-m-d H:i:s') : null,
            );
        }
	    
        return $view;
    }
	
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $productClass) {
            if (!$productClass instanceof ProductClass) {
                throw new BadRequestHttpException();
            }

            $view[] = array(
                'id' => $productClass->getId(),
                'code' => $productClass->getCode(),
		'price01' => $productClass->getPrice01(),
		'price02' => $productClass->getPrice02(),
		'create_date' => $productClass->getCreateDate() ?
		    $productClass->getCreateDate()->format('Y-m-d H:i:s') : null,
		'update_date' => $productClass->getUpdateDate() ?
		    $productClass->getUpdateDate()->format('Y-m-d H:i:s') : null,
            );
        }

        return $view[0];
    }

}
