<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\E2V;

use Eccube\Entity\Product;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;

/**
 * Class ProductE2V
 * @package Plugin\Proteger\E2V
 */
class ProductE2V 
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $product) {
            if (!$product instanceof Product) {
                throw new BadRequestHttpException();
            }

            $view[] = array(
                'id' => $product->getId(),
                'name' => $product->getName(),
		'categories' => $product->getProductCategories() ?
		    ProductCategoryE2V::convert($product->getProductCategories()->toArray()) : null,
		'image_urls' => $product->getProductImage() ? 
		    ProductImageE2V::convert($product->getProductImage()->toArray()) : null,
		'product_classes' => $product->getProductClasses() ?
		    ProductClassE2V::converts($product->getProductClasses()->toArray()) : null,
            );
        }

        return $view;
    }
}
