<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Entity;

use Doctrine\ORM\Mapping as ORM;
use Eccube\Annotation\EntityExtension;

/**
 * @EntityExtension("Eccube\Entity\CartItem")
 */
trait CartItemProtegerTrait
{

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $proteger_parent_product_name;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $proteger_parent_product_class_id;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $proteger_plan_id;

    /**
     * Set protegerParentProductName.
     *
     * @param  string  $proteger_parent_product_name
     *
     * @return ProtegerParentProductName
     */
    public function setProtegerParentProductName($proteger_parent_product_name)
    {
        $this->proteger_parent_product_name = $proteger_parent_product_name;

	return $this;
    }

    /**
     * Get protegerParentProductName.
     *
     * @return string
     */
    public function getProtegerParentProductName()
    {
        return $this->proteger_parent_product_name;
    }

    /**
     * Set protegerParentProductClassId.
     *
     * @param  string  $proteger_parent_product_class_id
     *
     * @return ProtegerParentProductClassId
     */
    public function setProtegerParentProductClassId($proteger_parent_product_class_id)
    {
        $this->proteger_parent_product_class_id = $proteger_parent_product_class_id;

	return $this;
    }

    /**
     * Get protegerParentProductClassId.
     *
     * @return integer
     */
    public function getProtegerParentProductClassId()
    {
        return $this->proteger_parent_product_class_id;
    }

    /**
     * Set protegerPlanId.
     *
     * @param  string  $proteger_plan_id
     *
     * @return ProtegerPlanId
     */
    public function setProtegerPlanId($proteger_plan_id)
    {
        $this->proteger_plan_id = $proteger_plan_id;

	return $this;
    }

    /**
     * Get protegerPlanId.
     *
     * @return string
     */
    public function getProtegerPlanId()
    {
        return $this->proteger_plan_id;
    }
}
