<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Class Proteger
 *
 * @ORM\Table(name="plg_proteger")
 * @ORM\Entity(repositoryClass="Plugin\Proteger\Repository\ProtegerRepository")
 */
class Proteger
{
    /**
     * @var integer ID
     * 
     * @ORM\Id
     * @ORM\Column(name="id", type="integer", options={"unsigned":true})
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
 
    /**
     * @var string Access Token
     *
     *  @ORM\Column(name="access_token", type="string", length=255, nullable=false)
     */
    private $accessToken;

    /**
     * @var string Store ID
     *
     *  @ORM\Column(name="store_id", type="string", length=36, nullable=false)
     */
    private $storeId;

    /**
     * @var integer Production Enabled
     *
     * @ORM\Column(name="production_enabled", type="boolean", options={"default":false})
     */
    private $productionEnabled = false;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAccessToken(): ?string
    {
        return $this->accessToken;
    }

    public function getStoreId(): ?string
    {
        return $this->storeId;
    }

    /**
     * Set accessToken.
     *
     * @param string|null $accessToken
     *
     * @return Proteger
     */
    public function setAccessToken($accessToken = null)
    {
        $this->accessToken = $accessToken;

        return $this;
    }

    /**
     * Set storeId.
     *
     * @param string|null $storeId
     *
     * @return Proteger
     */
    public function setStoreId($storeId = null)
    {
        $this->storeId = $storeId;

        return $this;
    }

    /**
     * Set productionEnabled.
     *
     * @param boolean $productionEnabled
     *
     * @return Proteger
     */
    public function setProductionEnabled($productionEnabled)
    {
        $this->productionEnabled = $productionEnabled;

        return $this;
    }

    /**
     * Get productionEnabled.
     *
     * @return boolean
     */
    public function isProductionEnabled()
    {
        return $this->productionEnabled;
    }
}
