<?php
/*
 * (c) Kiva Corp.
 */

namespace Plugin\Proteger\Service;

class ProtegerApiService
{
    public function getPlan($planId, $accessToken, $productionEnabled)
    {
	if ($productionEnabled) {
	    $url = 'https://api.helloproteger.com/v1/plans/'.$planId;
	} else {
	    $url = 'https://demo-api.helloproteger.com/v1/plans/'.$planId;
	}

	$options = [
	    'http' => [
		'method' => 'GET',
		'header' => [
		    'X-Proteger-Auth-Token: '.$accessToken,
		    'Content-Type: application/json',
		],
	    ]
	];

	try {
	    $context = stream_context_create($options);
	    $response = file_get_contents($url, false, $context);
	} catch (\Exception $e) {
	    log_info('Error: '.$e->getMessage());
	    return;
	}

	return $response;
    }

    public function createContract($accessToken, $requestBody, $productionEnabled)
    {
	if ($productionEnabled) {
            $url = 'https://api.helloproteger.com/v1/eccube4/event/create-contract-order';
	} else {
	    $url = 'https://demo-api.helloproteger.com/v1/eccube4/event/create-contract-order';
	}

	$options = [
	    'http' => [
		'method' => 'POST',
		'content' => $requestBody,
		'header' => [
		    'X-Proteger-Auth-Token: '.$accessToken,
		    'Content-Type: application/json',
		],
	    ]
	];

	try {
	    $context = stream_context_create($options);
	    $response = file_get_contents($url, false, $context);
	} catch (\Exception $e) {
	    log_info('Error: '.$e->getMessage());
	    return;
	}

	return $response;
    }

    public function refundContract($accessToken, $requestBody, $productionEnabled)
    {
	if ($productionEnabled) {
	    $url = 'https://api.helloproteger.com/v1/eccube4/event/refund-contract-order';
	} else {
            $url = 'https://demo-api.helloproteger.com/v1/eccube4/event/refund-contract-order';
	}
	$options = [
	    'http' => [
		'method' => 'POST',
		'content' => $requestBody,
		'header' => [
		    'X-Proteger-Auth-Token: '.$accessToken,
		    'Content-Type: application/json',
		],
	    ]
	];

	try {
	    $context = stream_context_create($options);
	    $response = file_get_contents($url, false, $context);
	} catch (\Exception $e) {
	    log_info('Error: '.$e->getMessage());
	    return;
	}

	return $response;
    }

    public function product($accessToken, $requestBody, $productionEnabled)
    {
	if ($productionEnabled) {
	    $url = 'https://api.helloproteger.com/v1/eccube4/event/product';
	} else {
            $url = 'https://demo-api.helloproteger.com/v1/eccube4/event/product';
	}

	$options = [
	    'http' => [
		'method' => 'POST',
		'content' => $requestBody,
		'header' => [
		    'X-Proteger-Auth-Token: '.$accessToken,
		    'Content-Type: application/json',
		],
	    ]
	];

	try {
	    $context = stream_context_create($options);
	    $response = file_get_contents($url, false, $context);
	} catch (\Exception $e) {
	    log_info('Error: '.$e->getMessage());
	    return;
	}

	return $response;
    }
}
